<template>
  <v-btn
    rounded
    prepend-icon="mdi-note-plus-outline"
    class="text-teal-600"
    variant="tonal"
  >
    Добавить

    <v-menu
      v-model="isShown"
      location="top start"
      transition="scale-transition"
      activator="parent"
      :close-on-content-click="false"
    >
      <Container
        class="my-4 p-4 drop-shadow-md shadow-none"
        reset-paddings
      >
        <div class="mb-2 font-light text-lg text-gray-500 uppercase">
          Новая заметка
        </div>

        <v-text-field
          v-model="newNote"
          :rules="[validateNote]"
          :maxlength="MAX_GUEST_NOTE_LENGTH"
          placeholder="Текст заметки"
          class="min-w-[16rem]"
        />

        <section class="pt-4">
          <v-btn
            rounded
            variant="tonal"
            class="font-bold mr-4"
            @click="isShown = false"
          >
            Отмена
          </v-btn>

          <v-btn
            rounded
            class="text-white font-bold bg-gradient-to-r from-teal-400 to-cyan-500"
            :class="{ 'opacity-50': !isDataFilled }"
            :readonly="!isDataFilled"
            @click="onCreateClick"
          >
            Создать
          </v-btn>
        </section>
      </Container>
    </v-menu>
  </v-btn>
</template>

<script setup lang="ts">
import { computed, ref, watch } from 'vue';

import { createStringValidator } from '@/validators';
import { MIN_GUEST_NOTE_LENGTH, MAX_GUEST_NOTE_LENGTH } from '@/declarations';

import Container from '@/components/layout/Container.vue';

const emit = defineEmits(['create']);

const validateNote = createStringValidator({
  required: true,
  length: { min: MIN_GUEST_NOTE_LENGTH, max: MAX_GUEST_NOTE_LENGTH },
});

const isShown = ref(false);
const newNote = ref('');

const isDataFilled = computed(() => {
  return validateNote(newNote.value) === true;
});

const onCreateClick = () => {
  emit('create', newNote.value.trim());
  isShown.value = false;
};

watch(isShown, () => newNote.value = '');
</script>